bus error in test_gil test on armhf with 64bit kernel

Bug #1821869 reported by Matthias Klose on 2019-03-27
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Python
New
Unknown
python3.6 (Ubuntu)
Bionic
Undecided
Unassigned
Cosmic
Undecided
Unassigned
python3.7 (Ubuntu)
High
Dave Jones
Bionic
Undecided
Unassigned
Cosmic
Undecided
Unassigned
Disco
High
Dave Jones

Bug Description

bus error in test_gil test on armhf with 64bit kernel

https://objectstorage.prodstack4-5.canonical.com/v1/AUTH_77e2ada1e7a84929a74ba3b87153c0ac/autopkgtest-disco/disco/armhf/p/python3.7/20190327_025457_8b623@/log.gz

test_extra_sha3 (test.test_hashlib.HashLibTestCase) ... ok
test_get_builtin_constructor (test.test_hashlib.HashLibTestCase) ... ok
test_gil (test.test_hashlib.HashLibTestCase) ... Fatal Python error: Bus error

Current thread 0xf7bcd210 (most recent call first):
  File "/usr/lib/python3.7/test/test_hashlib.py", line 788 in test_gil
  File "/usr/lib/python3.7/unittest/case.py", line 615 in run
  File "/usr/lib/python3.7/unittest/case.py", line 663 in __call__
  File "/usr/lib/python3.7/unittest/suite.py", line 122 in run
  File "/usr/lib/python3.7/unittest/suite.py", line 84 in __call__
  File "/usr/lib/python3.7/unittest/suite.py", line 122 in run
  File "/usr/lib/python3.7/unittest/suite.py", line 84 in __call__
  File "/usr/lib/python3.7/unittest/suite.py", line 122 in run
  File "/usr/lib/python3.7/unittest/suite.py", line 84 in __call__
  File "/usr/lib/python3.7/unittest/runner.py", line 176 in run
  File "/usr/lib/python3.7/test/support/__init__.py", line 1899 in _run_suite
  File "/usr/lib/python3.7/test/support/__init__.py", line 1995 in run_unittest
  File "/usr/lib/python3.7/test/libregrtest/runtest.py", line 178 in test_runner
  File "/usr/lib/python3.7/test/libregrtest/runtest.py", line 182 in runtest_inner
  File "/usr/lib/python3.7/test/libregrtest/runtest.py", line 137 in runtest
  File "/usr/lib/python3.7/test/libregrtest/main.py", line 305 in rerun_failed_tests
  File "/usr/lib/python3.7/test/libregrtest/main.py", line 623 in _main
  File "/usr/lib/python3.7/test/libregrtest/main.py", line 586 in main
  File "/usr/lib/python3.7/test/libregrtest/main.py", line 640 in main
  File "/usr/lib/python3.7/test/__main__.py", line 2 in <module>
  File "/usr/lib/python3.7/runpy.py", line 85 in _run_code
  File "/usr/lib/python3.7/runpy.py", line 193 in _run_module_as_main
Bus error (core dumped)

CVE References

Matthias Klose (doko) on 2019-03-27
tags: added: rls-dd-incoming
Changed in python3.7 (Ubuntu):
importance: Undecided → High
Changed in python:
status: Unknown → New
Changed in python3.7 (Ubuntu):
assignee: nobody → Dave Jones (waveform)
tags: added: disco
removed: rls-dd-incoming
tags: added: id-5c9ced775a657d0844321451
Dave Jones (waveform) wrote :

This turned out to be a mis-aligned access in the _sha3 module. There's a NO_MISALIGNED_ACCESSES define that can be used on the relevant platform (armhf) to fix it. Fixed package uploaded to https://launchpad.net/~waveform/+archive/ubuntu/pkg

Dave Jones (waveform) on 2019-04-03
Changed in python3.7 (Ubuntu Disco):
status: New → In Progress
Changed in python:
status: New → Confirmed
Changed in python3.6 (Ubuntu Disco):
status: New → Invalid
Changed in python3.6 (Ubuntu Cosmic):
status: New → Triaged
Changed in python3.6 (Ubuntu Bionic):
status: New → Triaged
Changed in python3.7 (Ubuntu Bionic):
status: New → In Progress
Changed in python3.7 (Ubuntu Cosmic):
status: New → Triaged
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package python3.7 - 3.7.3-2

---------------
python3.7 (3.7.3-2) unstable; urgency=medium

  * d/p/arm-alignment.diff: Don't allow unaligned memory accesses in the
    _sha3 extension (Dave Jones). LP: #1821869. Issue #36515.
  * Tweak the asyncio/ssl test again.

 -- Matthias Klose <email address hidden> Wed, 03 Apr 2019 07:39:12 +0200

Changed in python3.7 (Ubuntu Disco):
status: In Progress → Fix Released

Hello Matthias, or anyone else affected,

Accepted python3.7 into cosmic-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/python3.7/3.7.3-2~18.10 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-cosmic to verification-done-cosmic. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-cosmic. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in python3.7 (Ubuntu Cosmic):
status: Triaged → Fix Committed
tags: added: verification-needed verification-needed-cosmic
Changed in python3.6 (Ubuntu Cosmic):
status: Triaged → Fix Committed
Łukasz Zemczak (sil2100) wrote :

Hello Matthias, or anyone else affected,

Accepted python3.6 into cosmic-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/python3.6/3.6.8-1~18.10 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-cosmic to verification-done-cosmic. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-cosmic. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

no longer affects: python3.6 (Ubuntu Disco)
no longer affects: python3.6 (Ubuntu)
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package python3.6 - 3.6.8-1~18.10

---------------
python3.6 (3.6.8-1~18.10) cosmic-proposed; urgency=medium

  * PPA upload.
  * SRU: LP: #1822993. Update to the 3.6.8 release.
  * d/p/arm-alignment.diff: Don't allow unaligned memory accesses in the
    _sha3 extension (Dave Jones). LP: #1821869. Issue #36515.

python3.6 (3.6.8-1) unstable; urgency=medium

  * Python 3.6.8 release.
  * Revert the link optimization changes which appeared after the
    release candidate.

python3.6 (3.6.8~rc1-1) unstable; urgency=medium

  * Python 3.6.8 release candidate 1.
  * Update symbols files.

 -- Matthias Klose <email address hidden> Tue, 09 Apr 2019 06:59:38 +0200

Changed in python3.6 (Ubuntu Cosmic):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package python3.7 - 3.7.3-2~18.10

---------------
python3.7 (3.7.3-2~18.10) cosmic; urgency=medium

  * SRU: LP: #1822993. Update to the 3.7.3 release.

python3.7 (3.7.3-2) unstable; urgency=medium

  * d/p/arm-alignment.diff: Don't allow unaligned memory accesses in the
    _sha3 extension (Dave Jones). LP: #1821869. Issue #36515.
  * Tweak the asyncio/ssl test again.

python3.7 (3.7.3-1) unstable; urgency=medium

  * Python 3.7.3 release.
  * Work around issue #35988, reducing the payload size for the asyncio/ssl
    tests.

python3.7 (3.7.3~rc1-1) unstable; urgency=medium

  * Python 3.7.3 release candidate 1.
  * CVE-2019-9636. Fix issue #36216: Add check for characters in netloc that
    normalize to separators. Closes: #924072.
  * Use a build profile for libbluetooth-dev (<!pkg.python3.7.nobluetooth>).

python3.7 (3.7.2-3) unstable; urgency=medium

  * Update to 20190227 from the 3.7 branch.
  * Add more breaks for packages not compatible with Python 3.7:
    - xapers. Closes: #916914.
  * Move the test/ann_module{,2,3} modules into libpython-stdlib.
    Closes: #922285.
  * Limit the import checks for some extension modules to native builds.
    Closes: #921742.

python3.7 (3.7.2-2) unstable; urgency=medium

  * Update to 20190202 from the 3.7 branch.

python3.7 (3.7.2-1) unstable; urgency=medium

  * Python 3.7.2 release.
  * Revert the link optimization changes which appeared after the
    release candidate.
  * Make the build compatible with sphinx 1.6.x.
  * Loosen the pyzo break. Closes: #916548.

python3.7 (3.7.2~rc1-1) unstable; urgency=medium

  * Python 3.7.2 release candidate 1.
  * Add more breaks for packages not compatible with Python 3.7:
    - python3-dns. Closes: #912988.
    - python3-dkim. Closes: #912084.
    - pyzo. Closes: #914332.
  * Update VCS attributes. Closes: #904097.
  * Update symbols files.

 -- Matthias Klose <email address hidden> Tue, 09 Apr 2019 06:56:51 +0200

Changed in python3.7 (Ubuntu Cosmic):
status: Fix Committed → Fix Released
Changed in python:
status: Confirmed → Unknown
Changed in python:
status: Unknown → New
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package python3.7 - 3.7.3-2~18.04.1

---------------
python3.7 (3.7.3-2~18.04.1) bionic; urgency=medium

  * Rebuild with OpenSSL 1.1.1. LP: #1797386

 -- Dimitri John Ledkov <email address hidden> Wed, 03 Apr 2019 20:16:38 +0100

Changed in python3.7 (Ubuntu Bionic):
status: In Progress → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.